<template>
  <div class="container mt-3">
    <div class="row">
      <div class="col-md-10">
        <h1>Update Person</h1>
        <hr/>
        <div v-if="currentPerson">
          <div class="form-group row">
            <label for="adi" class="col-md-2 col-form-label">Adi</label>
            <div class="col-md-6">
              <input type="text" class="form-control" id="adi" required name="adi" v-model="currentPerson.adi">
            </div>
          </div>
          <br>
          <div class="form-group row">
            <label for="soyadi" class="col-md-2 col-form-label">Soyad</label>
            <div class="col-md-6">
              <input type="text" class="form-control" id="soyadi" required name="soyadi" v-model="currentPerson.soyadi">
            </div>
          </div>
          <br>
          <div class="mb-3">
            <button @click="updatePerson" class="btn btn-primary me-3">Update</button>
            <button @click="deletePerson" class="btn btn-danger">Delete</button>
          </div>
          <div class="alert alert-success" role="alert" v-if="message">
            {{ message }}
          </div>
        </div>
      </div>
    </div>
  </div>

</template>

<script>
import PersonService from "../services/PersonService";

export default {
  name: 'edit-person',
  data() {
    return {
      currentPerson: null,
      message: ''
    }
  },
  methods: {
    getPerson(id) {
      PersonService.get(id)
          .then(response => {
            this.currentPerson = response.data
          })
          .catch(e => {
            alert(e)
          })
    },
    updatePerson() {
      PersonService.update(this.currentPerson.id, this.currentPerson)
          .then(() => {
            this.message = 'The person was updated successfully!'
          })
          .catch(e => {
            alert(e)
          })
    },
    deletePerson() {
      PersonService.delete(this.currentPerson.id)
          .then(() => {
            this.$router.push({name: 'persons'})
          })
          .catch(e => {
            alert(e)
          })
    }
  },
  mounted() {
    this.getPerson(this.$route.params.id)
  }
}
</script>